#line 1 "C:/_MikroC/_MesProjets_MikroC/_16F1847_OWS_DS18B20/_16F1847_OWS_2xDS18B20_Temp_LCD_I2C_170327.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 1 "c:/_mikroc/_mesprojets_mikroc/_16f1847_ows_ds18b20/../common/delays.h"
#line 50 "c:/_mikroc/_mesprojets_mikroc/_16f1847_ows_ds18b20/../common/delays.h"
extern void DelayMs(unsigned char);
extern void DelaySec(char sec);
void Tempo_1mS(void);
void Tempo_XmS(unsigned int x);

unsigned char N1;


void Tempo_XmS(unsigned int t)
{
 int t1;
 t1=t;
 while(t1>0)
 {
 Tempo_1mS();
 t1--;
 }
}


void Tempo_1mS()
{
_asm{
 MOVLW 210 ;
 MOVWF _N1;
 ici:
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 decfsz _N1 ,F ;
 bra ici ;
 nop;
 nop;
 nop;
 nop;
 } ;
 }
#line 111 "C:/_MikroC/_MesProjets_MikroC/_16F1847_OWS_DS18B20/_16F1847_OWS_2xDS18B20_Temp_LCD_I2C_170327.c"
const code char mesg0[]="                    ";
const code char mesg1[]=" Compilateur : " "MikroC 7.0.1" "\n\r";
const code char mesg2[]=" Directory :" "C:\\_MikroC\\_MesProjets_MikroC\\_16F1847_OWS_DS18B20" "\r\n";
const code char mesg3[]=" Projet    :" "16F1847_OWS_18B20_temper_2017.mcppi" "\r\n";
const code char mesg4[]=" Source    :" "_16F1847_OWS_2xDS18B20_Temp_LCD_I2C" "_" "170327" ".c\r\n";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4};

char TEXTE[80];
char * txt;
char CRam1[64];
char *p;
unsigned int i,j,k,l,m;




unsigned char buffer1[ 80 ];
unsigned int Index1=0;
unsigned int UART1_DataReady=0;
unsigned int i1=0;
unsigned char c1;
int CptErr;

unsigned int Cpt1;
int Etat;
int addr;




const unsigned short TEMP_RESOLUTION = 12;
char *Temper = "000.0000";
unsigned int temp;



unsigned char SENSOR_ADDRESS[2][8]=
{
 { 0, 0, 0, 0, 0, 0, 0, 0 },
 { 0, 0, 0, 0, 0, 0, 0, 0 }
};



unsigned char Valid_Sensor;
char Degres;
char Signe;

unsigned long DS18B20_Temp1;
unsigned int temp_fraction;
char TH1=19;
char TL1=15;

unsigned long DS18B20_Temp2;
char TH2=20;
char TL2=14;
char c2;


 unsigned char Buff_LCD[17];


void Read_Msg_Eeprom(unsigned char depuis);
void Init_Hardware(void);
void Init_Timer1(void);
void Float2Ascii (float x, unsigned char *str,char precision);
void strConstRamCpy(char *dest, const char *source);
void Special_Init_UART_RB2_RB5(void);
void RAZ_UART1(void);
void UART1_Write_CText(const char *txt1);
void CRLF1(void);

char Convert_Temperature(unsigned int temp2write);
void Adresse_Device_DS18B20(int N);
void Lecture_ID_Sensor(int NS);




void LCD_CLS(void);
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void LCD_Write_Chr_At(int Ligne,int col,char c1,int special);
void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1);
void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1);
void LCD_Write_CText(const char * t1);
void Cree_Euro(void) ;
void Cree_8_cars_CGRAM(void) ;
void LCD_Cde(unsigned char Cde);
void LCD_Gauche(void);
void LCD_Droite(void);


void Interrupts() iv 0x0004 ics ICS_AUTO
{
 if ( (RCIE_bit) && ( PIR1.RCIF))
 {


 if (RCSTA.OERR==1)
 {
 RCSTA.CREN = 0 ;
 c1 = RCREG;
 RCSTA.CREN = 1 ;
 CptErr++;
 }
 if(RCSTA.FERR==1 )
 {
 RCSTA.SPEN = 0 ;
 RCSTA.SPEN= 1 ;
 CptErr++;
 c1 = RCREG;
 }
 c1 = RCREG;
 if (c1== 13 )
 {
 UART1_DataReady=1;
 PIE1.RCIE=0 ;
 buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 else
 {
 buffer1[i1]=c1;
 Index1=i1;
 i1++;
 if (i1>= 80 ) i1=0;
 }
 }
}


char Convert_Temperature(unsigned int temp2write)
{
 const unsigned int RES_SHIFT = TEMP_RESOLUTION - 8;
 char i;
 char temp_whole;
 DS18B20_Temp1=0;

 if (temp2write & 0x8000) {
 Signe=1;
 temp2write = ~temp2write + 1;
 }
 else
 Signe=0;

 temp_whole = temp2write >> RES_SHIFT ;
 if (Signe==1) temp_whole= -temp_whole;
 DS18B20_Temp1= ( long)temp_whole;

 temp_fraction = temp2write << (4-RES_SHIFT);
 temp_fraction &= 0x000F;
 temp_fraction *= 625;
 DS18B20_Temp1= DS18B20_Temp1 *10000 + (unsigned long)temp_fraction;
 return(temp_whole);
}

void Adresse_Device_DS18B20(int N)
{
 int i;
 Ow_Reset(&PORTA, 1);




 Delay_us(250);
 Ow_Write(&PORTA, 1,  0x55  );
 for (i=0;i<8;i++)
 {
 Ow_Write(&PORTA, 1, SENSOR_ADDRESS[N-1][i]) ;
 Delay_us(250);
 }
 Delay_us(250);
 }


void Update_Thresholds(int numX)
{
 int i;

 Adresse_Device_DS18B20(numX);

 Ow_Write(&PORTA, 1,  0x4E );
 Delay_us(750);
 switch(numX)
 {
 case 1:
 {
 Ow_Write(&PORTA, 1, TH1);
 Delay_us(750);
 Ow_Write(&PORTA, 1, TL1);
 break;
 }
 case 2:
 {
 Ow_Write(&PORTA, 1, TH2);
 Delay_us(750);
 Ow_Write(&PORTA, 1, TL2);
 break;
 }
 }
 Delay_us(750);
 Ow_Write(&PORTA, 1, 0x7F);
 Delay_us(750);
 Adresse_Device_DS18B20(numX);
 Delay_us(750);
 Ow_Write(&PORTA, 1,  0x48 );
 UART1_Write_CText(" ->stored in DS18B20\r\n");
 CRLF1();
}


void Lecture_ID_Sensor(int NS)
{ unsigned int AC;
 int i;
 unsigned char cx;
 UART1_Write_CText("\r\n1 seul DS18B20 doit etre connect\r\n");
 Ow_Reset(&PORTA, 1);
 Ow_Write(&PORTA, 1,  0x33 );
 Delay_us(750);
 cx=Ow_Read(&PORTA, 1);
 strConstRamCpy(txt , "Data: FamilyCode .. ID.= xxxxxxxxxxxx CRC= ..");
 *(txt+22)=NS+48;





 ByteToHex(cx,CRam1);
 AC=0x00A0 + NS*16 ;

 EEPROM_Write(AC,cx);
 SENSOR_ADDRESS[NS-1][0]=cx;
 Delay_ms(5);
 memcpy(txt+17,CRam1,2);
 for (i=1;i<7;i++)
 {
 cx= Ow_Read(&PORTA, 1);

 EEPROM_Write(AC+i,cx);
 SENSOR_ADDRESS[NS-1][i]=cx;
 Delay_ms(5);
 ByteToHex(cx,CRam1);
 memcpy(txt+23+i*2,CRam1,2);
 }
 cx= Ow_Read(&PORTA, 1);
 EEPROM_Write(AC+i,cx);
 SENSOR_ADDRESS[NS-1][7]=cx;
 ByteToHex(cx,CRam1);

 memcpy(txt+43,CRam1,2);
 UART1_Write_Text(txt);
 CRLF1() ;
 Delay_ms(25);
 Valid_Sensor=Valid_Sensor | NS;
}


void RAZ_UART1()
{ int i1;
 for (i1=0;i1< 80 ;i1++) buffer1[i1]=0;
 Index1=0;
 i1=0;
 c1=RCREG;
 c1=0;
 UART1_DataReady=0;

 PIE1.RCIE=1 ;
}

void UART1_Write_CText(const char *txt1)
 {
 while (*txt1)
 UART1_Write(*(txt1++));
}


void strConstRamCpy(char *dest, const char *source)
 {
 while(*source) *(dest++) = *(source++) ;
 *dest = 0 ;
}

void CRLF1()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
 }

void Read_Msg_Eeprom(unsigned char debut)
{ int i1 ;
unsigned char c;
 i1=debut;
 do
 {
 c = EEPROM_Read(i1);
 if ( c==0) break;
 if ( i1>254) break;
 UART1_Write(c);
 Delay_ms(5);
 i1++;
 }
 while (c!=0) ;
 }

void Init_Hardware()
{
 TRISB = 0xFF;
 TRISA = 0xFF;
 PORTA=0;

 ANSELA = 0b00000000;

 ANSELB = 0;

 WPUA5_bit=1;
 WPUB=0;

 TRISB.B1 = 1;
 TRISB.B4 = 0;
 TRISB.B5 = 0;
 TRISB.B2 = 1;
 TRISB.B6 = 1;

 CM1CON0=0;
 CM1CON1=0;
 CM2CON0=0;
 CM2CON1=0;
}

void Special_Init_UART1_RB2_RB5(void)
{
#line 457 "C:/_MikroC/_MesProjets_MikroC/_16F1847_OWS_DS18B20/_16F1847_OWS_2xDS18B20_Temp_LCD_I2C_170327.c"
 APFCON0.SDO1SEL=1;
 APFCON0.SS1SEL=1;
 APFCON0.RXDTSEL=1;
 APFCON1.TXCKSEL=1;
 BAUDCON.WUE=0;
 CPSCON0 = 0 ;
 TRISB.B2=1;
 }


void Init_Timer1(void)
{


 T1CON=0;






 TMR1CS1_bit=1;
 TMR1CS0_bit=0;


 T1CKPS1_bit=0;
 T1CKPS0_bit=0 ;
 T1OSCEN_bit=0;
 T1CON.B2=1;




 TMR1ON_bit=1;


 TMR1GE_bit=0;
 T1GPOL_bit=0;
 T1GTM_bit=0;
 T1GSPM_bit=0;

 T1GSS1_bit=0;
 T1GSS0_bit=0;
 Cpt1=0;

}


void Float2Ascii (float x, unsigned char *str,char precision)
{


 unsigned char *adpt;
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;

 if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

 if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
 while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }

 ndig += ie;


 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
 *str = '\0';
}



void LCD_CLS()
{

LCD_RAZ_Ligne(2);
LCD_RAZ_Ligne(1);
}

int LCD2119_Init(void)
{

int j,k;
k=0;
Delay_ms(500);
 I2C1_Start ();
j= I2C1_Wr ( 0x74 );
if (j!=0) return k;
k++;
Delay_ms(200);
j= I2C1_Wr (0x00);
if (j>0) return k;
k++;
 I2C1_Wr (0x24);
 I2C1_Wr (0x0C);
 I2C1_Wr (0x06);
 I2C1_Wr (0x25);

 I2C1_Wr (0x06);
 I2C1_Wr (0x11);
 I2C1_Wr (0x42);

 I2C1_Wr (0x96);
j= I2C1_Wr (0x24);
if (j>0) return k;
k++;
j= I2C1_Wr (0x0C);
if (j>0) return k;
k++;
j= I2C1_Wr (0x06);
if (j>0) return k;
k++;
j= I2C1_Wr (0x02);
if (j>0) return k;
k++;


j= I2C1_Wr (0x01);
if (j>0) return k;
Delay_ms(100);
 I2C1_Stop ();
k++;
return k;
}

void LCD_RAZ_Ligne( int L)
{
int i;
  I2C1_Start ();
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x00);
  I2C1_Wr (0x02);
 switch (L)
 {
 case 1:
  I2C1_Wr (0x80);
 break;
 case 2:
  I2C1_Wr (0xC0);
 break;
 default:
 break ;
 }
  I2C1_Repeated_Start ();
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x40);
 for (i=0;i< 16 ;i++)
 {
  I2C1_Wr (0x80+32);
 }

  I2C1_Repeated_Start ();
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x00);

 switch (L)
 {
 case 1:
  I2C1_Wr (0x80);
 break;
 case 2:
  I2C1_Wr (0xC0);
 break;
 default:
 break ;
 }
  I2C1_Stop ();
}

void LCD_Write_CText(const char * t1)
 {
 char TT[21];
 int i;
 strConstRamCpy(TT,t1);
  I2C1_Start ();
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x00);
  I2C1_Repeated_Start ();
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x40);
 i=0;
 while(*(t1))
 {
  I2C1_Wr (0x80+*(t1));
 t1++;
 i++;

 }
  I2C1_Stop ();
}

void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1)
 {
 char TT[21];
 int i;
 strConstRamCpy(TT,t1);
  I2C1_Start ();
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x00);
 if(col> 16 ) col= 16 ;
 switch (Ligne)
 {
 case 1:
  I2C1_Wr (0x80+col-1);
 break;
 case 2:
  I2C1_Wr (0xc0+col-1);
 break;
 default:
 break ;
 }
  I2C1_Repeated_Start ();
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x40);
 i=col;
 while(*(t1))
 {
  I2C1_Wr (0x80+*(t1));
 t1++;
 i++;
 if (i> 16 ) break;
 }
  I2C1_Stop ();
}

void LCD_Write_Chr_At(int Ligne,int col,char c1,int Special)
{


  I2C1_Start () ;
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x00);
 if(col> 16 ) col=  16 ;
 switch (Ligne)
 {
 case 1:
  I2C1_Wr (0x80+col-1);
 break;
 case 2:
  I2C1_Wr (0xc0+col-1);
 break;
 default:
 break ;
 }
  I2C1_Repeated_Start () ;
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x40);
 if (Special==1)  I2C1_Wr (c1); else  I2C1_Wr (0x80+c1);
  I2C1_Stop ();
 }

void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1)
{

 int i;
  I2C1_Start ();
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x00);
 if(col> 16 ) col= 16 ;
 switch (Ligne)
 {
 case 1:
  I2C1_Wr (0x80+col-1);
 break;
 case 2:
  I2C1_Wr (0xc0+col-1);
 break;
 default:
 break ;
 }
  I2C1_Repeated_Start ();
  I2C1_Wr ( 0x74 );
  I2C1_Wr (0x40);
 i=col;
 while(*(t1))
 {
  I2C1_Wr (0x80+*(t1));
 t1++;
 i++;
 if (i> 16 ) break;
 }
  I2C1_Stop ();
}

void LCD_Home()
{
 LCD_Cde(0x02);
}

void LCD_Cde(unsigned char Cde)
{
  I2C1_Start ();
  I2C1_Wr (0x76);
  I2C1_Wr (0x00);
  I2C1_Wr (Cde);
  I2C1_Stop ();
}


void check_device(unsigned char dev_address)
{
strConstRamCpy(txt,"Device at adresse : ");
k=strlen(txt);
ByteToStr(dev_address,CRam1);
strcat(txt+k,CRam1);
UART1_Write_Text(txt);
 I2C1_Start ();
if( I2C1_Wr (dev_address)!=0 )
 {
 UART1_Write_CText(" is not found");
 }
 else
 {
 UART1_Write_CText(" found OK");
 }
 I2C1_Stop ();
 CRLF1();
}

void Decompile_byte(unsigned char un)
{
 unsigned char masque;
 masque = 0x80;
 while (masque > 0u )
 {
 if ((un & masque)>0)
 UART1_Write(49u);
 else
 UART1_Write(48u);
 masque =masque >>1;
 }
}


void Cree_8_cars_CGRAM()
{
unsigned char b1,b2;
 I2C1_Start();
 I2C1_Wr( 0x74 );
 I2C1_Wr(0x00);

 I2C1_Wr(0x40);

 I2C1_Repeated_Start() ;
 I2C1_Wr( 0x74 );
 I2C1_Wr(0x40);


I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
 b2=32;
 b1=0;
 for (i=0;i<5;i++)
 {
 b2=b2>>1;
 b1=b1+b2;
 for (j=0;j<8;j++)
 {

 UART1_Write_CText("I2C1_Wr(");
 Decompile_byte(b1);
 CRLF1();

 I2C1_Wr(b1);

 }

 CRLF1();

 }


 I2C1_Wr (0b00000000);
 I2C1_Wr (0b00001110);
 I2C1_Wr (0b00010001);
 I2C1_Wr (0b00001110);
 I2C1_Wr (0b00000000);
 I2C1_Wr (0b00000000);
 I2C1_Wr (0b00000000);
 I2C1_Wr (0b00000000);


I2C1_Wr(0x06);
I2C1_Wr(0x09);
I2C1_Wr(0x08);
I2C1_Wr(0x1E);
I2C1_Wr(0x1E);
I2C1_Wr(0x08);
I2C1_Wr(0x09);
I2C1_Wr(0x06);

I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0011111);
I2C1_Wr(0b0010001);
I2C1_Wr(0b0011111);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Stop();
}
#line 934 "C:/_MikroC/_MesProjets_MikroC/_16F1847_OWS_DS18B20/_16F1847_OWS_2xDS18B20_Temp_LCD_I2C_170327.c"
void main()
 {


 OSCCON =0;
 OSCCON.IRCF3=1;
 OSCCON.IRCF2=1;
 OSCCON.IRCF1=1;
 OSCCON.IRCF0=0;
 OSCCON.SCS1=1;


 Init_Hardware() ;




 Delay_ms(1000);

 txt=TEXTE;
 UART1_Init(19200);
 Delay_ms(100);

 Special_Init_UART1_RB2_RB5();
 Delay_ms(100);
 while(PIR1.RCIF==1) c1 = RCREG;
 UART1_Write( 12 );
 Delay_ms(500);
 UART1_Write_CText("\r\n Init Speciale UART: Rx RB2 et TX RB5\r\n");
 for (i=1;i<4;i++) UART1_Write_CText(Messages[i]);
 CRLF1();
 Read_Msg_Eeprom(0);
 Read_Msg_Eeprom(0x40);
 Read_Msg_Eeprom(0xE0);
 CRLF1(); CRLF1();


 UART1_Write_CText("ID #1 ");
 c1=EEPROM_Read(0xB0);
 if (c1!=0x28) UART1_Write_CText("?\r\n");
 else
 {
 for (i=0;i<8;i++)
 {
 c1=EEPROM_Read(0xB0+i);
 SENSOR_ADDRESS[0][i] =c1;
 ByteToHex(c1,CRam1) ;
 UART1_Write_Text(CRam1);UART1_Write(' ');
 }
 CRLF1();
 Valid_Sensor.B0=1;
 }

 c1=EEPROM_Read(0xC0);
 UART1_Write_CText("ID #2 ");
 if (c1!=0x28) UART1_Write_CText("?\r\n");
 else
 {
 for (i=0;i<8;i++)
 {
 c1=EEPROM_Read(0xC0+i);
 SENSOR_ADDRESS[1][i] =c1;
 ByteToHex(c1,CRam1);
 UART1_Write_Text( CRam1);UART1_Write(' ');
 }
 CRLF1();
 Valid_Sensor.B1=1;
 }
 txt=&TEXTE[0];


 RAZ_UART1();
 PIE1.RCIE=1;
 PEIE_bit=1;
 GIE_bit=1;



 I2C1_Init(400000);


 CRLF1();
 addr= 0x74 ;
 check_device(addr);
 UART1_Write_CText(" Init Display LCD2119\r\n");
 k=0;
 k= LCD2119_Init();
 LCD_CLS();
 WordToStr(k,txt);
 UART1_Write_CText(" Nb Step = ");
 UART1_Write_Text(txt); UART1_Write_CText(" sur 7\r\n");
 CRLF1();
 if (k==7) LCD_Write_CText_At(1,1,"Init LCD en 7pas");
 Delay_ms(2000);

 LCD_Write_CText_At(1,1,"Version : " "170327" );
 LCD_Write_CText_At(2,1,"Mesure de Temper.");
 Delay_ms(4000);
 LCD_CLS();
 LCD_Write_CText_At(1,1,"2 Sensor DS18B20");
 LCD_Write_CText_At(2,1,"Temperature Amb.");
 Delay_ms(4000);

 Cree_8_cars_CGRAM();

 LCD_CLS();
 LCD_Write_CText_At(1,1,"Affi.8 car CGRAM");
 for (i=0;i<8;i++)
 {
 LCD_Write_Chr_At(2,i+1,i,1);
 }
 LCD_Write_Chr_At(2,10,0,1);
 Delay_ms(5000);


 CRLF1();
 RAZ_UART1();

 PIE1.RCIE=1;
 PEIE_bit=1;
 GIE_bit=1;

 j=0;

 do {
 txt=&TEXTE[0];
 strConstRamCpy(txt , "j=255;T1=+100.00;T2=+100.00;\r");
 ByteToStr((unsigned char)j,CRam1);
 memcpy(txt+2,CRam1,3);
 if (Valid_Sensor.B0==1)
 {

 Adresse_Device_DS18B20(1);
 Ow_Write(&PORTA, 1, 0x44  );
 Delay_ms(10);
 Adresse_Device_DS18B20(1);
 Delay_ms(10);
 Ow_Write(&PORTA, 1, 0xBE );

 temp = Ow_Read(&PORTA, 1);
 temp = (Ow_Read(&PORTA, 1) << 8) + temp;

 TH1= Ow_Read(&PORTA, 1);
 TL1= Ow_Read(&PORTA, 1);

 strConstRamCpy(Buff_LCD , "Tamb1= *000.00C");


 Degres=Convert_Temperature(temp);
 ByteToStr(Degres,CRam1) ;
 memcpy(Buff_LCD+8,CRam1,3);
 if (Signe==1)
 {
 *(txt+9)='-';
 *(Buff_LCD+7)='-';
 }
 else
 {
 *(txt+9)=' ';
 *(Buff_LCD+7)=' ';
 }
 memcpy(txt+10,CRam1,3);
 WordToStrWithZeros (temp_fraction,CRam1);
 memcpy(txt+14,CRam1+1,2) ;
 memcpy(Buff_LCD+12,CRam1+1,2);
 *(Buff_LCD+14)=8;


 LCD_Write_Text_At(1,1,Buff_LCD);
 LCD_Write_Chr_At(1,15,6,1);


 }

 if(Valid_Sensor.B1==1)
 {

 Adresse_Device_DS18B20(2);
 Ow_Write(&PORTA, 1, 0x44  );
 Delay_ms(10);
 Adresse_Device_DS18B20(2);
 Delay_ms(10);
 Ow_Write(&PORTA, 1, 0xBE );

 temp = Ow_Read(&PORTA, 1);
 temp = (Ow_Read(&PORTA, 1) << 8) + temp;

 TH2= Ow_Read(&PORTA, 1);
 TL2= Ow_Read(&PORTA, 1);



 strConstRamCpy(Buff_LCD , "TExt.= +000.00C");
 Degres=Convert_Temperature(temp);
 ByteToStr(Degres,CRam1) ;
 memcpy(Buff_LCD+8,CRam1,3);
 if (Signe==1)
 {
 *(txt+20)='-';
 *(Buff_LCD+7)='-';
 }
 else
 {
 *(txt+20)=' ';
 *(Buff_LCD+7)=' ';
 }

 memcpy(txt+21,CRam1,3);
 WordToStrWithZeros (temp_fraction,CRam1);
 memcpy(txt+25,CRam1+1,2) ;
 memcpy(Buff_LCD+12,CRam1+1,2);



 LCD_Write_Text_At(2,1,Buff_LCD);
 LCD_Write_Chr_At(2,15,6,1);

 }
 UART1_Write_Text(txt);
 j++;
 j=j & 0x00FF;

 Delay_ms(1000);

 }
 while(1);
 }
